-- Used on the altfire can. Hooks up a few actors to the ground and zaps them.
function RandPlusMinus(Integer)
	local Rand = math.random(0,1);
	local Num = Integer;
	if Rand == 1 then
		Num = Num * (-1)
	else
		Num = Num * (1)
	end
	return Num;
end

function DrawLine(StartPosition, EndPosition, DrawLengthMultiplier, DrawingQuality, MOPixelToDrawWith)	
	local VectorToDestination = SceneMan:ShortestDistance(StartPosition,EndPosition,true) * DrawLengthMultiplier;
	local ParticleCount = VectorToDestination.Magnitude * DrawingQuality;
	local DistanceMultiplier = (1 / DrawingQuality);
	for ParticleNumber = 0, ParticleCount, 1 do
		local Particle = CreateMOPixel(MOPixelToDrawWith);
		Particle.Pos = StartPosition + VectorToDestination.Normalized * DistanceMultiplier * ParticleNumber;
		MovableMan:AddParticle(Particle);
	end
end

function DrawFracturedLine(StartPosition, EndPosition, AmountOfFractures, ExcessSegmentLength, DrawingQuality, DeviationFromCenter, MOPixelToDrawWith)
	local VectorToDestination = SceneMan:ShortestDistance(StartPosition,EndPosition,true);
	local DistBetweenFracts = VectorToDestination.Magnitude / AmountOfFractures;
	local List = {};
	for ParticleNumber = 0, AmountOfFractures, 1 do
		if ParticleNumber == 0 then
			local Particle = CreateMOPixel(MOPixelToDrawWith);
			Particle.Pos = StartPosition;
			MovableMan:AddParticle(Particle);
			List[ParticleNumber] = Particle;
		else
			local Rand = DeviationFromCenter - math.random(0,DeviationFromCenter) * RandPlusMinus(1);
			local Offset = VectorToDestination.Normalized.Perpendicular * Rand; 
			local Particle = CreateMOPixel(MOPixelToDrawWith);
			Particle.Pos = StartPosition + VectorToDestination.Normalized * DistBetweenFracts * ParticleNumber + Offset;
			MovableMan:AddParticle(Particle);
			List[ParticleNumber] = Particle;
		end
	end
	for i = 0, #List, 1 do
		local nexti = i + 1;
		if nexti <= #List then
			DrawLine(List[i].Pos, List[nexti].Pos, ExcessSegmentLength, DrawingQuality, MOPixelToDrawWith);
		end
	end
end

function Create(self)
	self.Grab = 0; -- It hasn't grabbed anything yet
	self.LinePow = 15;
	self.TargetList = {};
	self.Listed = false;
	self.temp = 0;
	self.Angle = self.RotAngle;
	self.StartTimer = Timer();

	self.Parent = nil;

	local curdist = 50; -- Gets the actor shot the hook and sets it to self.Parent
	for actor in MovableMan.Actors do
	local dist = SceneMan:ShortestDistance(self.Pos,actor.Pos,true).Magnitude;
		if dist < curdist then
			curdist = dist;
			self.Parent = actor;
		end
	end
end


function Update(self)
	self.ToSettle = false;

	if (self.Grab == 0) then -- If we haven't grabbed anything yet
		local curdist = 100;
		self.Frame = 0;
		for actor in MovableMan.Actors do
			local dist = SceneMan:ShortestDistance(self.Pos,actor.Pos,true).Magnitude;
			if dist < curdist then
				if actor.ID ~= self.Parent.ID then
					self.Pretemp = self.temp - 1;
					if self.Pretemp < 0 then
						self.TargetList[self.temp] = actor;
						self.TargetList[self.temp].Broken = false;
						self.TargetList[self.temp].ZapTimer = Timer();
						self.temp = self.temp + 1
						self.Listed = true;
					elseif actor.ID ~= self.TargetList[self.Pretemp].ID then
						self.TargetList[self.temp] = actor;
						self.TargetList[self.temp].Broken = false;
						self.TargetList[self.temp].ZapTimer = Timer();
						self.temp = self.temp + 1
						self.Listed = true;
					end
				end
			end
		end

		if #self.TargetList > 1 or self.StartTimer:IsPastSimMS(1750) then
			if self.Listed then
				local j = SceneMan:MovePointToGround(self.Pos, 5, 5);
				self.Pos = j;
				self.PinStrength = 5000;
				self.Grab = 1;
				self.GetsHitByMOs = true;
				self:EnableEmission(false);

				local clicksound = CreateAEmitter("Click Sound Emitter"); -- Play a "click" sound
				clicksound.Pos = self.Pos;
				MovableMan:AddParticle(clicksound);
			end
		end
	elseif (self.Grab == 1)  then -- If we've grabbed a MOID then
		self.RotAngle = math.rad(270);
		self.Frame = 1;
		for i = 0, #self.TargetList, 1 do
			if MovableMan:ValidMO(self.TargetList[i]) then
				if self.TargetList[i].Broken == false then
					self.TargetList[i].Broken = BetterGrapple(self.TargetList[i], self, 100, 200, self.LinePow);
					if self.TargetList[i].ZapTimer:IsPastSimMS(2500) then
						DrawFracturedLine(self.TargetList[i].Pos, self.Pos, 7, 1.2, 1, 7, "Particle Zap");
						self.TargetList[i].ZapTimer:Reset();

						if self.TargetList[i].Health ~= nil then
							self.TargetList[i].Health = self.TargetList[i].Health - 10;
						end
						local Bang = CreateMOSRotating("Zap Wound");
						Bang.Pos = self.TargetList[i].Pos;
						MovableMan:AddParticle(Bang);
						Bang:GibThis();

						local zapsound = CreateAEmitter("Zap Sound Emitter");
						zapsound.Pos = self.Pos;
						MovableMan:AddParticle(zapsound);
					end
				end
			else
				table.remove(self.TargetList, i);
			end
		end

		if #self.TargetList == 0 then
			self:GibThis();
		end
	end
end
